/*
 * Revision Control Information
 *
 * $Source: /vol/opua/opua2/sis/sis-1.1/common/src/sis/command/RCS/com_int.h,v $
 * $Author: sis $
 * $Revision: 1.5 $
 * $Date: 1992/05/06 18:51:44 $
 *
 */

#if STDC_HEADERS
#  include <string.h>
#  include <stdlib.h>
#else
void free();
char *strncpy();
#endif

/*
 * This is for Solaris -- it needs to be convinced that we're actually
 * using BSD-style calls in sys/ioctl.h, otherwise it doesn't find
 * "ECHO" "CRMOD" and "TIOCSTI" when compiling cmdFile.c
 */
#define BSD_COMP

#if IOCTL_WITH_TERMIOS
#  include <sys/ioctl.h>
#  include <sys/termios.h>
#else
#  if HAVE_SYS_IOCTL_H
#    include <sys/ioctl.h>
#  else
#    if HAVE_SYS_TERMIOS_H
#      include <sys/termios.h>
#    endif
#  endif
#endif

/* Linux and its wacky header files... */
#if HAVE_BSD_SGTTY_H
#  include <bsd/sgtty.h>
#endif

#if HAVE_SYS_SIGNAL_h
#  include <sys/signal.h>
#endif
#if HAVE_SIGNAL_H
#  include <signal.h>
#endif

/*
 * No unix system seems to be able to agree on how to access directories,
 * which cmdFile.c needs to do.  This solution, suggested by the autoconf
 * distribution, seems to handle most of the nonsense.
 */

#if HAVE_DIRENT_H
#  include <dirent.h>
#  define NAMLEN(dirent) strlen((dirent)->d_name)
#else
#  define dirent direct
#  define NAMLEN(dirent) (dirent)->d_namlen
#  if HAVE_SYS_NDIR_H
#    include <sys/ndir.h>
#  endif
#  if HAVE_SYS_DIR_H
#    include <sys/dir.h>
#  endif
#  if HAVE_NDIR_H
#    include <ndir.h>
#  endif
#endif

#include <setjmp.h>

#define MAX_STR		1024

typedef int (*PFI)();

typedef struct command_descr_struct command_descr_t;
struct command_descr_struct {
    char *name;
    PFI command_fp;
    int changes_network;
};


typedef struct alias_descr_struct alias_descr_t;
struct alias_descr_struct {
    char *name;
    int argc;
    char **argv;
};


typedef struct network_info_struct network_info_t;
struct network_info_struct {
    network_t *network;
    network_t *original;
    lsList history;
};

/* Strings for communicating with a graphical front end, used in commisc.c */

#define COM_GRAPHICS_MSG_START		"#START-GRAPHICS-COMMAND\n"
#define COM_GRAPHICS_MSG_END		"#END-GRAPHICS-COMMAND\n"

extern char sis_hist_char;
extern char sis_shell_char;

extern avl_tree *command_table;
extern avl_tree *flag_table;
extern avl_tree *alias_table;
extern network_t *backup_network;

extern int com_alias();
extern int com_unalias();
extern int com_execute();
extern int com_help();
extern int com_time();
extern int com_echo();
extern int com_quit();
extern int com_set_variable();
extern int com_unset_variable();
extern int com_source();
extern int com_undo();

extern void com_free_argv();
extern void com_alias_free();
extern void com_command_free();

extern char *fgets_filec();
extern char *hist_subst();
extern void print_prompt();

